--===================================================
--
--				GHM_CustomDD
--  			GHM_CustomDD.lua
--
--	          (description)
--
-- 	  (c)2011 The Gryphonheart Team
--			All rights reserved
--===================================================

local count = 1;
function GHM_DropDown(parent, main, profile)
	
	local frame = CreateFrame("Frame","GHM_DropDown"..count,parent,"GHM_DropDown_Template")
	
	local label = _G[frame:GetName().."Label"];
	local area = _G[frame:GetName().."Area"];
	local ddFrame = _G[area:GetName().."DD"];
	local ddText = _G[ ddFrame:GetName().."Text"];
	local ddButton = _G[ddFrame:GetName().."Button"]
	
	frame:SetWidth(profile.width or 80)
	
	local returnIndex = profile.returnIndex;	
	label:SetText(profile.text or "");
	
	local OnSelect = profile.OnSelect;
	local menuFrame
	
	ddFrame:SetBackdrop({
                bgFile = "Interface/Tooltips/UI-Tooltip-Background",
                edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
                tile = true, tileSize = 16, edgeSize = 16,
                insets = { left = 4, right = 4, top = 4, bottom = 4 }
                });
	ddFrame:SetBackdropColor(0,0,0,0.5);
	
	local function CreateGHMDDMenu(list)
		local t = {
			{
			},
			name = "GHI_DD_Menu" .. count,
			theme = "BlankTheme",
			width = (profile.width - 24) or 36,
			useWindow = false,
		}
		for i,v in pairs(list) do
			local button = {
				{
				},
			}
			if type(v) == "table" then
				button[1].type = "TextButton"
				button[1].text = v.text
				button[1].value = v.value or v.text
				button[1].index = i
				button[1].onClick = function(self)
					ddFrame.index = self.index
					ddFrame.value = self.value
					ddText:SetText(v.text)
					
					v.OnClick(self)
					
					if profile.OnSelect then
						profile.OnSelect(self.index, self.value)
					end
					
					menuFrame:Hide()
				end,
				table.insert(t[1],button)
			elseif type(v) == "string" then
				button[1].type = "TextButton"
				button[1].text = v
				button[1].value = v
				button[1].index = i
				button[1].OnClick = function(self)
					ddFrame.index = self.index
					ddFrame.value = self.value
					ddText:SetText(v)
					if profile.OnSelect then
						profile.OnSelect(self.index, self.value)
					end
					menuFrame:Hide()
				end,
				table.insert(t[1],button)
			end
		end
		menuFrame = GHM_NewFrame(frame,t)
		menuFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background",
			edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
			tile = true,
			tileSize = 16,
			edgeSize = 16, 
			insets = { left = 4, right = 4, top = 4, bottom = 4 }
		})
		menuFrame:SetBackdropBorderColor(TOOLTIP_DEFAULT_COLOR.r, TOOLTIP_DEFAULT_COLOR.g, TOOLTIP_DEFAULT_COLOR.b);
		menuFrame:SetBackdropColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r, TOOLTIP_DEFAULT_BACKGROUND_COLOR.g, TOOLTIP_DEFAULT_BACKGROUND_COLOR.b);
		menuFrame:SetPoint("TOPLEFT",ddFrame,"BOTTOMLEFT",0,-4)
		menuFrame:Hide()
	end
	
	ddButton:SetScript("OnClick", function(self)
		if menuFrame:IsShown() then
			menuFrame:Hide()
		else
			menuFrame:Show()
		end
	end)
	
	count = count + 1
	if profile.data then
		if type(profile.data) == "table" then
			CreateGHMDDMenu(profile.data or {})
			frame.data = profile.data or {}
		elseif type(profile.data) == "function" then
			local list = profile.data()
			CreateGHMDDMenu(list)
			frame.data = list
		else
			CreateGHMDDMenu({})
		end
	end
	
	GHM_FramePositioning(frame,profile,parent);
	
	frame.EnableVariableAttributeInput = function(self, scriptingEnv, item)
        if not (varAttFrame) then
            varAttFrame = GHM_VarAttInput(frame, area, frame:GetWidth());
            frame:SetHeight(frame:GetHeight());
        end
        varAttFrame:EnableVariableAttributeInput(scriptingEnv, item, profile.outputOnly)
    end

    frame.GetValue = function(self) -- Get the current value
        if (varAttFrame and not (varAttFrame:IsStaticTabShown())) then
            return varAttFrame:GetValue();
        else
            if returnIndex then
				return ddFrame.index;
			end
			return ddFrame.value;
        end
    end
	
	local varAttFrame;

   --[[ Force1 = function(data)
        -- Set the value and ui to 'data', evt using help functions
		if returnIndex then
			ddFrame.index = data;
			ddFrame.value = GetData()[index];
		else
			local t = GetData();
			index = 1;
			for i=1,#(t) do
				if t[i] == data then
					index = i;
					break;
				end
			end
			value = data;
		end
		ddLabel:SetText(value);
		if OnSelect then
			OnSelect(index);
		end
    end

    local Force2 = function(inputType, inputValue)
        if (inputType == "attribute" or inputType == "variable") and varAttFrame then -- Handles input to var/Att frame
            varAttFrame:SetValue(inputType, inputValue);

        else -- static
            varAttFrame:Clear();
            Force1(inputValue);
        end
    end

    frame.Force = function(self, ...) -- Calls Force1 or Force2 depending on the number of inputs. Either Force(value) or Force(Type,value)
        if self ~= frame then return frame.Force(frame, self, ...); end
        local numInput = #({ ... });

        if numInput == 1 then
            Force1(...);
        elseif numInput == 2 then
            Force2(...);
        end
    end]]

    frame.Clear = function(self)
        -- Clear the value / ui to a default state
		ddFrame.value = frame.data[1];
		ddFrame.index = 1;
		ddText:SetText(ddFrame.value);
    end

    -- Trigger evt onLoad function
    if type(profile.OnLoad) == "function" then
        profile.OnLoad(frame);
    end
	
	--[[area:Show()
	ddFrame:Show()]]
    frame:Show();
	frame.Clear()
    return frame;
end