--===================================================
--
--				GHM_TextButton
--  			GHM_TextButton.lua
--
--	          (A button that appears as only text.)
--
-- 	  (c)2013 The Gryphonheart Team
--			All rights reserved
--===================================================

local count = 1;
function GHM_TextButton(parent, main, profile)
	local frame = CreateFrame("Button","GHM_TextButton" .. count, parent);
	
	count = count + 1;

	local font = GHI_FontList[profile.font] or "Fonts\\FRIZQT__.TTF"
	local fontSize = profile.fontSize or 11
		
	local label = frame:CreateFontString(frame:GetName().."Label", "ARTWORK")
	label:SetPoint("LEFT",frame,"LEFT",0,0)
	label:SetFont(font,fontSize)
	label:SetText(profile.text)
	label:SetHeight(label:GetStringHeight() + 4)
	label:SetWidth(label:GetStringWidth() + 4)
	
	frame:SetHeight(profile.height or label:GetHeight());
	frame:SetWidth(profile.width or label:GetWidth());
	
	if profile.value then
		frame.value = profile.value
	end
	
	if profile.index then
		frame.index = profile.index
	end
	
	-- Click handler
	if profile.OnClick then
		frame:SetScript("OnClick",profile.OnClick)
	end
	if profile.onClick then
		frame:SetScript("OnClick",profile.onClick)
	end

	-- Tooltip
	frame:SetScript("OnEnter", function()
		if profile.tooltip then
			GameTooltip:SetOwner(frame, "ANCHOR_RIGHT");
			GameTooltip:ClearLines()
			GameTooltip:AddLine(profile.tooltip, 1, 0.8196079, 0);
			GameTooltip:Show()
		end
	end);
	frame:SetScript("OnLeave", function(self)
		GameTooltip:Hide();
	end);

	-- Frame positioning
	GHM_FramePositioning(frame,profile,parent);
	frame:Show()
	
	return frame;
end

